package flock;

import java.awt.*;
import java.awt.event.ActionListener;

public class MyMenuBar extends MenuBar implements ActionListener
{
	MyMenuBar myMenuBar;
	MyMenuBar(){
		super();
		myMenuBar = this;

		Menu fileMenu = new java.awt.Menu("File");
		add(fileMenu);
		fileMenu.add(new MyMenuItem("clear"));
		fileMenu.add(new MyMenuItem("loadImage"));
		fileMenu.add(new MyMenuItem("exit"));
	}


	class MyMenuItem extends MenuItem {
		MyMenuItem(String label){
			super();
			setLabel(label);
			addActionListener(myMenuBar);
		}
	}
	
	public void actionPerformed(java.awt.event.ActionEvent event)
	{
		if (event.getSource() instanceof MyMenuItem){
			String label = ((MyMenuItem)event.getSource()).getLabel();
			if (label.equals("clear"))
				MainPanel.mainPanel.clear();
			else if (label.equals("loadImage"))
				MainPanel.mainPanel.loadImage();
			else if (label.equals("exit"))
				System.exit(0);

		}

	}


}
