package flock;

import java.util.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import javax.swing.*;

public class Primitive
{
	Point position = new Point(100, 100);
	double scale = 1;
	double angle = 0;
	
	
	Primitive(){
	}
	
	
	void draw(Graphics g){
		Graphics2D g2 = (Graphics2D) g;
		
		AffineTransform af = new AffineTransform();
		af.translate(position.x, position.y);
		af.rotate(angle * Math.PI/180);
		af.scale(scale, scale);
		af.translate(-width/2, -height/2);
		
		g2.drawImage(image, af, null);
		
	}
	
	
	
	
	
	
	
	public boolean picked(Point p){
		int r = (int)((width + height)/4 * scale);
		return ((p.x - position.x)*(p.x - position.x)+(p.y - position.y)*(p.y - position.y) < r*r);
	}
	
	public void move_relative(int dx, int dy){
		position.x += dx;
		position.y += dy;
	}
	
	
	
	public void duplicate(){
		MainPanel.mainPanel.current_primitive = get_duplicated() ;
		MainPanel.mainPanel.primitives.add( MainPanel.mainPanel.current_primitive );
	}
	public Primitive get_duplicated(){
		Primitive primitive = new Primitive();
		primitive.position.x = position.x + 20;
		primitive.position.y = position.y + 20;
		primitive.scale = scale;
		primitive.angle = angle;
		return primitive;
	}

	
	
	
	//
	// PopupMenȕ
	//
	static MyPopupMenu popupMenu= null;
	void show_popupmenu(int x, int y){
		if (popupMenu == null){
			popupMenu = new MyPopupMenu(MainPanel.mainPanel);
			popupMenu.addLabel("duplicate");
			popupMenu.addLabel("rotate_left");
			popupMenu.addLabel("rotate_right");
			popupMenu.addLabel("enlarge");
			popupMenu.addLabel("shrink");
			popupMenu.addLabel("front");
			popupMenu.addLabel("back");
		}
		popupMenu.target = this;
		popupMenu.show(MainPanel.mainPanel, x, y);
	}
	void popupMenu_selected(String label){
		if (label.equals("duplicate"))
			duplicate();
		else if (label.equals("rotate_left"))
			angle -= 15;
		else if (label.equals("rotate_right"))
			angle += 15;
		else if (label.equals("enlarge"))
			scale *= 1.25;
		else if (label.equals("shrink"))
			scale *= 0.8;
		else if (label.equals("front")){
			MainPanel.mainPanel.primitives.remove(this);
			MainPanel.mainPanel.primitives.add(this);
		}
		else if (label.equals("back")){
			MainPanel.mainPanel.primitives.remove(this);
			MainPanel.mainPanel.primitives.add(0,this);
		}
		MainPanel.mainPanel.repaint();
		
	}
	
	
	
	
	
	
	
	//
	// 摜̓ǂݍ
	//
	static void loadImage(String filename){
		Image new_image = MainPanel.mainPanel.getToolkit().getImage( filename );
		if (new_image == null)
			return;
		
		image = new_image;
		if (image != null) {
			MediaTracker mt = new MediaTracker(MainPanel.mainPanel);
			try	{
				mt.addImage(image, 0);
				mt.waitForAll();
			}	catch (InterruptedException ie) {}
		}
		
		width = image.getWidth(null);
		height = image.getHeight(null);
	}
	static Image image;
	static int width;
	static int height;

	
	
}
